<?
include "config.inc.php";
include "script/sqlite.inc.php";
  
function ReverseGeocoding($latlon){
  global $GOOGLE_KEY, $GOOGLE_SRV_ADDR, $GOOGLE_SRV_PORT, $GOOGLE_SRV_TOUT;
  $fp = @fsockopen($GOOGLE_SRV_ADDR, $GOOGLE_SRV_PORT, $errno, $errstr, $GOOGLE_SRV_TOUT);
  if (!$fp) return 0;
  if($DEBUG) echo "Connessione con GOOGLE\t[OK]<br>";
  $GET_QUERY  = "GET /maps/geo?q=$latlon&output=csv&sensor=false&key=$GOOGLE_KEY&oe=utf-8 HTTP/1.1\r\n";
  $GET_QUERY .= "Host: $GOOGLE_SRV_ADDR\r\n";
  $GET_QUERY .= "User-Agent: Mozilla/5.0\r\n";
  $GET_QUERY .= "\r\n\r\n";
  @fputs($fp, $GET_QUERY, strlen($GET_QUERY));
  if($DEBUG) echo "Trasmissione con GOOGLE\t[OK]<br>";
  for ($i=0; $i<11; $i++) $BUFFER .=  fgets($fp, 1024);
  @fclose($fp);
  //Separo l'header
  $res = explode("\r\n\r\n", $BUFFER);
  if(count ($res)>0) 
    $BUFFER = $res[1];
    $res = explode("\"", $BUFFER);
    if(count ($res)>1) 
      return $res[1];
  return 0;
}

function GetTIMEZONE($lat,$lon){
  global  $WS_SRV_ADDR, $WS_SRV_PORT, $WS_SRV_TOUT;
  //http://ws.geonames.org/timezone?lat=47.01&lng=10.2
  //http://www.earthtools.org/timezone-1.1/47.01/10.2
  $fp = @fsockopen($WS_SRV_ADDR, $WS_SRV_PORT, $errno, $errstr, $WS_SRV_TOUT);
  if (!$fp) return 0;
  if($DEBUG) echo "Connessione\t[OK]<br>";
  $GET_QUERY  = "GET /timezone/$lat/$lon HTTP/1.1\r\n";
  //$GET_QUERY  = "GET /timezone?lat=$lat&lng=$lon HTTP/1.1\r\n";
  $GET_QUERY .= "Host: $WS_SRV_ADDR\r\n";
  $GET_QUERY .= "User-Agent: Mozilla/5.0\r\n";
  $GET_QUERY .= "\r\n\r\n";
  @fputs($fp, $GET_QUERY, strlen($GET_QUERY));
  for ($i=0; $i<16; $i++) $BUFFER .=  fgets($fp, 1024);
  @fclose($fp);
  //if(eregi("<rawOffset>([0-9]+).([0-9]+)</rawOffset>", $BUFFER, $ret)) {
  if(eregi("<offset>([0-9]+)</offset>", $BUFFER, $ret)) {
    return (int)$ret[1];
  }
  return 0;
}


//Gestione DB SQLITE
$db1=new sqlite();
$db1->db_file="globalix.sqlite";
$db1->db_debug=0;
$res = $db1->sqlite_open();
$query = "CREATE TABLE globalix (id INTEGER PRIMARY KEY, password VARCHAR(10), gps_data VARCHAR(100), device_id VARCHAR(50));";
$res = $db1->sqlite_query($query);



//Salvataggio dei DATI in SQLITE
if(!empty($_REQUEST[PW]) && !empty($_REQUEST[PR])){
  //Salva Le informazioni in un File (si pu rimuovere)
  $tmp ="$_REQUEST[PW] - $_REQUEST[PR] - $_REQUEST[ID]";
  $fp = @fopen ("log.log", "a");
  fwrite ($fp, $tmp . "\r\n");
  fclose ($fp);
  
  //Salva le informazioni nel database
  $query = "INSERT INTO globalix VALUES (NULL, '$_REQUEST[PW]', '$_REQUEST[PR]', '$_REQUEST[ID]')";
  $res = $db1->sqlite_query($query);
  
  if($res)
    echo "1,20,0";
  else
    echo "0,0,0";
  return(0);
}

//Genera XML
if(!empty($_REQUEST[XML]) && $_REQUEST[XML]=="get"){
  header("Content-type: text/xml"); 
  header("Content-disposition: filename=index.xml");
  header("Pragma: no-cache"); 
  header("Expires: 0");
  print"<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n";

  //Ricavo l'ultima coordinata inserita:
  $query = "SELECT * FROM globalix ORDER BY id DESC LIMIT 1";
  $res = $db1->sqlite_query($query);
  echo "<ROOT>";
  if(sqlite_num_rows ($db1->query_return)>0){
    
    $rec = sqlite_fetch_array ($db1->query_return); 
    //4 - 1234 - 4542.8100,N,01344.2665,E,207.5,0.19,23.59,141206,151957.999,05,2 - 0000000001
    
    $COORDINATE = explode(",", $rec[gps_data]);
    if(count ($COORDINATE)<10) {
      //ShowError("Formato Cordinate non valido");
      echo "<ERROR>1</ERROR>";
      echo "</ROOT>";
      return 0;
    }
    //Ricavo la latitudine
    $latitude =(int)substr($COORDINATE[0],0,2) + (float)(substr($COORDINATE[0],2,7)) / 60; //Latitudine 
    $latitude = substr($latitude,0,9);
    $DIR_1 = $COORDINATE[1];
    //Ricavo la longitudine
    $longitude =(int)substr($COORDINATE[2],1,2) + (float)(substr($COORDINATE[2],3,7)) / 60; //Latitudine 
    $longitude = substr($longitude,0,9);
    $DIR_2 = $COORDINATE[3];
    //Altitudine 
    $ALTITUDE=$COORDINATE[4];
    //Velocit
    $SPEED=(int)$COORDINATE[5] * 1.609;
    $CURSE=$COORDINATE[6];

    echo "<LATITUDE>" . $latitude . "</LATITUDE>";
    echo "<DIR_LATITUDE>" . $DIR_1 . "</DIR_LATITUDE>";
    echo "<LONGITUDE>" . $longitude . "</LONGITUDE>";
    echo "<DIR_LONGITUDE>" . $DIR_2 . "</DIR_LONGITUDE>";
    echo "<ALTITUDE>" . $ALTITUDE . "</ALTITUDE>";
    echo "<SPEED>" . $SPEED . "</SPEED>";
    echo "<CURSE>" . $CURSE . "</CURSE>";
    //echo $CURSE . "<br>";

    //ORARIO
    //Booleano ora legale (1 se c' l'ora legale, 0 altrimenti)
    //mktime(hour,minute,second,month,day,year,is_dst)
    $timestamp= mktime(substr($COORDINATE[8],0,2),substr($COORDINATE[8],2,2),substr($COORDINATE[8],4,2),substr($COORDINATE[8],2,2),substr($COORDINATE[8],0,2) ,substr($COORDINATE[8],4,2));
    $LEGAL = 0;
    if(date("I", $timestamp)) $LEGAL = 1;
    $TIMEZONE=GetTIMEZONE($latitude,$longitude);
    $HOUR = (int)substr($COORDINATE[7],0,2) + $TIMEZONE + $LEGAL;
    $TIME = $HOUR . ":" . substr($COORDINATE[7],2,2) . ":" . substr($COORDINATE[7],4,2);
    if($TIMEZONE > 0){
      $TIMEZONE = "+$TIMEZONE";
    }
    echo "<TIME>" . $TIME . "</TIME>";
    //DATA
    $DATE = substr($COORDINATE[7],0,2) . "/" . substr($COORDINATE[7],2,2) . "/20" . substr($COORDINATE[7],4,2);
    echo "<DATE>" . $DATE . "</DATE>";
    echo "<ID>" . $rec[device_id] . "</ID>";
    echo "</ROOT>";
  } else {
    echo "<ERROR>0</ERROR>";
    echo "</ROOT>";
  }
  return 0;
}

?>
